<?php
/**
* ルミーズ決済モジュール・インストール処理
*
* PHP versions 4 and 5
* @project REMISE Payment Module for EC-CUBE 2.12.x
* @package mdl_remise
* @author REMISE Corp. <tech@remise.jp>
* @copyright Copyright(C) REMISE Corp. All Rights Reserved.
* @version install.php,v 2.1
*
*/

/**
* インストール処理のクラス.
*
* @package mdl_remise
* @author REMISE Corp. <tech@remise.jp>
* @version v 2.1
*/
class install{
    var $install_files;

    /**
     * コンストラクタ.
     *
     * @param string $customize カスタマイズのため上書きする？
     * @return void
     */
    function install($customize) {
        $this->install_files  = array(
            /* 本体クラスファイル */
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/LC_Page_Admin_Order_Edit_Ex.php',
                "dest" => DATA_REALDIR . 'class_extends/page_extends/admin/order/LC_Page_Admin_Order_Edit_Ex.php',
                "overwrite" => $customize,
                "backup" => true
            ),
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/LC_Page_Admin_Order_Ex.php',
                "dest" => DATA_REALDIR . 'class_extends/page_extends/admin/order/LC_Page_Admin_Order_Ex.php',
                "overwrite" => $customize,
                "backup" => true
            ),
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/LC_Page_Shopping_Complete_Ex.php',
                "dest" => DATA_REALDIR . 'class_extends/page_extends/shopping/LC_Page_Shopping_Complete_Ex.php',
                "overwrite" => $customize,
                "backup" => true
            ),
            /* 本体テンプレート */
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/edit.tpl',
                "dest" => TEMPLATE_ADMIN_REALDIR . 'order/edit.tpl',
                "overwrite" => $customize,
                "backup" => true
            ),
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/index.tpl',
                "dest" => TEMPLATE_ADMIN_REALDIR . 'order/index.tpl',
                "overwrite" => $customize,
                "backup" => true
            ),
            /* その他 */
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/remise_recv.php',
                "dest" => HTML_REALDIR . 'user_data/remise_recv.php',
                "overwrite" => true,
                "backup" => false
            ),
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/remise_receipt_mail.tpl',
                "dest" => SMARTY_TEMPLATES_REALDIR . 'default/mail_templates/remise_receipt_mail.tpl',
                "overwrite" => true,
                "backup" => true
            ),
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/img/',
                "dest" => HTML_REALDIR . 'user_data/mdl_remise/img/',
                "overwrite" => true,
                "backup" => false
            ),
            /***** 2012/01/31 追加（大池） start *****/
            array(
                "source" => MODULE_REALDIR . 'mdl_remise/inst/remise_order_cancel_mail.tpl',
                "dest" => SMARTY_TEMPLATES_REALDIR . 'default/mail_templates/remise_order_cancel_mail.tpl',
                "overwrite" => true,
                "backup" => true
            )
           /***** 2012/01/31 追加（大池） end   *****/
        );
    }

    /**
     * ファイルコピー.
     *
     * @return void
     */
    function filecopy() {
    	$objUtils = new SC_Utils();
        $errmsg = "";

        foreach ($this->install_files as $file) {
            $source = $file['source'];
            $dest = $file['dest'];
            $overwrite = $file['overwrite'];
            $backup = $file['backup'];


            //ファイルがないか、もしくはオーバーライト可の場合
            if(!file_exists($dest) || $overwrite) {
            	if(is_dir($source)){
            		// ディレクトリの場合
            		$objUtils->sfMakeDir($dest);
            		$backupfile = dirname($dest) . '/' . basename($dest) . '_' . date("Ymd") . '.backup';
            		if($backup){
            			$objUtils->sfCopyDir($dest, $backupfile);
            		}
            		// フォルダをコピー
            		$objUtils->sfCopyDir($source, $dest, $message, true);
            	}
            	else {
            		$backupfile = $file['dest'] . '_' . date("Ymd") . '.backup';
                    //バックアップを作成(ファイルが異なる場合のみ)
                	if($backup && sha1_file($source) != sha1_file($backupfile)) {
                    	copy($dest, $backupfile);
                	}
                	//ファイルをコピー
                	if(is_writable($dest) || is_writable(dirname($dest))) {
                    	copy($source, $dest);
                	} else {
                    	$errmsg = $dest . "に書き込み権限を与えてください。";
                    	break;
                	}
            	}
            }
        }
        return $errmsg;
    }

    function setInstallFiles($val) {
        $this->install_files = $val;
    }

    function getInstallFiles() {
        return $this->install_files;
    }
}
?>